

module qs.
export qsort(bf).
@pipelining.

% quicksort with difference-list representation of lists.

qsort(dlist([A|X],X),dlist([A|Y],Y)).
qsort(dlist([H|T],T1), Y) :- split(H,dlist(T,T1),X1,X2), qsort(X1,Y1), 
	qsort(X2,dlist(Y2,T2) ), dappend(Y1,dlist([H|Y2],T2),Y).

split(I, dlist(A,A), dlist(A,A), dlist(A,A)).
split(I, dlist([H|T],T1), X1, dlist([H|X2],T2)) :- I < H, 
		split(I, dlist(T,T1), X1, dlist(X2,T2)).
split(I, dlist([H|T], T1), dlist([H|X1], T2), X2) :- I >= H, 
		split(I, dlist(T,T1), dlist(X1,T2), X2).
end_module.

/*
?qsort(dlist([1|[2|[3|[4|[5|[6|[7|[8|[9|[0|X]]]]]]]]]],X),Z).


*/
