module nodups.      

/*  Removes duplicates from a list. */

export nodups(bf).  
@pipelining.

nodups([],[]).
nodups([X | L], ANS) :- nodups(L,M), addin(X,M,ANS).

addin(X,M,M) :- member(X,M).
addin(X,M,[X | M]) :-  not member(X,M).

% In prolog, you would use one if-then-else statement here,
% avoiding the duplicate test for member.

% Usual prolog defn of member.

member(X, [X | Tail]).
member(X, [Y | Tail]) :- member(X,Tail).


end_module.

