// *************************************************************************
//  Entity.C
// *************************************************************************


#include "Entity.h"

#include <stream.h>

int is_free(void*);

// *************************************************************************
void Cor_Entity_Array::delete_all()
{
    int j;

    for (j=0; j < ENTITY_ARRY_SZE; j++) {

        char *ch;
        Cor_Ent_Element *curr, *prev = NULL;
        for (curr=chnk_tab[j]; curr; curr=curr->next) {
            ch = (char *) prev;
            ::delete [] ch;
            prev = curr;
        }
        ch = (char *) prev;
        ::delete [] ch;

        chnk_tab[j] = NULL;
#ifdef    SHOW_ALLOC
        num_alloc[j] = 0;
        num_free[j] = 0;
#endif
    }
}

// *****************************************************************
void *Cor_Entity_Array::acquire(size_t size)
{
    int j, new_sze = sz_ceil(size);
    //ASSERT(new_sze <= MAX_CHUNK_SZE);
    Cor_Ent_Element *chnk;

    if (!this) {
        chnk = (Cor_Ent_Element *) ::new char [new_sze];
    } else {

#ifdef    SHOW_ALLOC
        num_alloc[index(new_sze)]++;
#endif
        chnk = chnk_tab[j = index(new_sze)];

        if (chnk) {
            chnk_tab[j] = chnk->next; 
        } else {
            chnk = (Cor_Ent_Element *) ::new char [new_sze];
        }
    }

    return((void*) chnk);
}

// *****************************************************************
void Cor_Entity_Array::dispose(Cor_Ent_Element *trash, size_t size)
{

#ifdef    DEBUG
    // Too expensive for all the time
    //  if (tmp_is_free(trash))
    //      ASSERT(0);
    ASSERT( ((unsigned int) trash) > 1000);
#endif

    if (!this) {
        char *ch = (char *) trash;
        ::delete [] ch;
    } else {
#ifdef    SHOW_ALLOC
        num_free[index(sz_ceil(size))]++;
#endif
        int j = index(sz_ceil(size));
        trash->next = chnk_tab[j];
        chnk_tab[j] = trash;
    }
}

// *****************************************************************
int  Cor_Entity_Array::tmp_is_free(Cor_Ent_Element *chk)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    return(is_free((void*) chk));
}
// *************************************************************************
void Cor_Entity_Array::show_all()
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    int  j;

    cout << "---------------\nThe Entity Array:\n";

    for (j=0; j < ENTITY_ARRY_SZE; j++) {
        int  cnt = 0;
        Cor_Ent_Element *curr;
        for (curr=chnk_tab[j]; curr; curr = curr->next)
            cnt++;

        if (cnt) {
#ifdef    SHOW_ALLOC
            cout << "size " << ((j+1)*ALIGN_SZE) << ": " << cnt
                 << " chunks.  (Allocated: " << num_alloc[j]
                 << " Freed: " << num_free[j] << ")\n";
#else
            cout << "size " << (j+1)*ALIGN_SZE << ": " << cnt
                 << " chunks.\n";
#endif
        }
    }

    cout << "---------------\n";
}

// *************************************************************************
// Is this item in the free list?
int is_free(void *mem)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    int  j;

    if (!Coral_Free)
        return(0);

    for (j=0; j < ENTITY_ARRY_SZE; j++) {
        Cor_Ent_Element *curr;
        for (curr=Coral_Free->chnk_tab[j]; curr; curr = curr->next) {
            if (curr == (Cor_Ent_Element*) mem)
                return(1);
        }
    }

    return(0);
}

// *************************************************************************
