/*****************************************************************************/
//    GenericHashTable.C
/*****************************************************************************/

#include "GenericHashTable.h"

#include "Globals.h"

/*****************************************************************************/
corGenericHashTable::corGenericHashTable(EqualsFn eqf1, int initsize1,
    double incr_ratio1, double max_occupancy1)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    if (incr_ratio1 <= 0.0)
        incr_ratio1 = corexEnv->C_incr_ratio_default;

    if (max_occupancy1 <= 0.0)
        max_occupancy1 = corexEnv->C_max_occupancy_default;

    equalsfn = eqf1;
    max_size = initsize1;
    cur_size = 0;
    incr_ratio = incr_ratio1;
    max_occupancy = max_occupancy1;
    limit = int(max_size * max_occupancy);
}

/*****************************************************************************/

