/*****************************************************************************/
//    GenericHashTable.h
/*****************************************************************************/

#ifndef _GenericHashTable_H_
#define _GenericHashTable_H_

/*****************************************************************************/

typedef int (*EqualsFn)(void*,void*);

/*****************************************************************************/

//    HashEntry must be a struct and not a class.  This is because bzero is
//    used immediately after allocating an array of these, and if there are
//    any methods, the method table will be overwritten.

typedef struct corHashEntry {
    void *data;
    int hashval;
    struct corHashEntry *next;
} corHashEntry;

/*****************************************************************************/

class corGenericHashTable {
public:
    EqualsFn equalsfn;
    int max_size;
    double incr_ratio;
    double max_occupancy;
    int cur_size;
    int limit;
     
    corGenericHashTable(EqualsFn eqf1, int initsize1=128,
        double incr_ratio1 = 1.5,
        double max_occupancy1 = 0.7);

    virtual void *insert(void *entry, int hashval, int& to_delete)=0;
    virtual void *lookup(void *entry, int hashval)=0;
};

/*****************************************************************************/

#endif _GenericHashTable_H_

