// *************************************************************************
//    ModuleInfo.h
// *************************************************************************

#ifndef _ModuleInfo_H_
#define _ModuleInfo_H_

#include "CArg.h"
#include "Profile.h"

// *************************************************************************

class Cor_ExportInfo;

// *************************************************************************

class Cor_ModuleInfo {

  public:
    Cor_CArg name;                    // Name of the module
    Cor_ExportInfo *ExportedPreds;    // List of exported queries
                                      // (preds with adornments)

#ifdef    DO_PROFILE
    Cor_ProfileInfo Cor_GlobalProfileInfo; // profile info for module
#endif

    int ExportedCount;             // Length of above list

    int PreProcessing;             // perform preprocessing on this module
    int SingleScc;                 // lump all rules into a single scc
    int ConvertFunctions;          // convert arithemetic functions
    int SingleAnswer;              // the exported relation has a single answer
                                   // per binding

    int Rewriting;                 // perform rewriting on this module

    int UseSupplementaryMagic;
    // This is probably redundant .. UseMagic, because of UseFactoring
    int UseMagic;                  // Do magic transformation if set
    int UseFactoring;              // Do factoring if set
    int UseFactorMagic;            // Do factoring with a magic predicate
                                   //   guarding every rule
    int CheckSubsum;               // Subsumption checking status
    int MultiSet;                  // MultiSet semantics
    int IndexDeltas;               // Index the deltas of all relations
    int UsePipelining;             // Use pipelined evaluation mode
    int UseOrdSearch;              // Use ordered search
    int LazyEval;                  // Use lazy evaluation
    int Monotonic;                 // Don't use done_m_ literals if set
    int DiskRel;                   // All derived relations are disk-resident
    int NaiveBacktrack;            // Use naive backtracking
    int NestedSccEval;             // Use nested-Scc evaluation

    Cor_ModuleInfo() { init(); };
   ~Cor_ModuleInfo();

    void init_flags();
    void init();
    void clear();
};

// *************************************************************************

#endif _ModuleInfo_H_
