// *************************************************************************
//    Catalog.h
// *************************************************************************

#ifndef _Catalog_H_
#define _Catalog_H_

class Cor_PersistentRel;

// *************************************************************************

class Cor_Catalog {
private:
    FID cat_fid;
    IID cat_iid;

    Cor_PersistentRel *prel;

public:

    Cor_Catalog() { prel = NULL; }
   ~Cor_Catalog();


    // Check if a file is in the catalog
    int lookupFile(char *name, OID * oid);

    // Add a file to the catalog, and returns the FileDesc structure in obj
    int addFile(char *file_name, Cor_FileDescStruct *obj);

    // Delete a file from the catalog index
    int deleteFile(char *file_name, OID *oid);

    // Initialize catalog
    int init(char *cat_file_name, char *cat_index_name);

    // List all files
    void listFiles(ostream *outf);
};

// *************************************************************************

#endif _Catalog_H_
