// *************************************************************************
//    Transaction.h
// *************************************************************************

#ifndef _Transaction_H_
#define _Transaction_H_

// *************************************************************************

class Cor_Transaction {
    friend class Cor_StorageManager;
private:
    TID tid;

public:
    Cor_Transaction()    { INVALIDATE_TID(tid) ;}

    void start()
    {
        if (TID_IS_INVALID(tid)) {
            int e = sm_BeginTransaction(&tid);
            ErrorCheck(e, "sm_BeginTransaction");
        }
    }

    int commit();

    void abort()
    {
        if (!TID_IS_INVALID(tid)) {
            int e = sm_AbortTransaction(tid);
            ErrorCheck(e, "sm_AbortTransaction");
        }
        INVALIDATE_TID(tid);
    }

};

// *************************************************************************

#endif _Transaction_H_
