// *************************************************************************
//    BasePreds.C
// *************************************************************************

#include "BasePreds.h"

#include "Rule.h"
#include "Literal.h"

// *************************************************************************
void mark_basepreds(Cor_Collection *rules)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    int p;
    Cor_Clause *rule;
    int j, nrules;

    nrules = rules->count();
    rules->use_hash_table(1);

    for (j=0; j < nrules; j++) {
        rule = rules->get_ith(j);

        for (p=0; p < rule->num_preds; ++p) {

            if (rules->get_match(rule->preds[p]->pred))
                rule->preds[p]->base_pred = 0;
            else
                rule->preds[p]->base_pred = 1;
        }
    }
}

// *************************************************************************
void mark_all_as_basepreds(Cor_Collection *rules)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    int p;
    Cor_Clause *rule;
    int j, nrules;

    nrules = rules->count();

    for (j=0; j < nrules; j++) {
        rule = rules->get_ith(j);

        for (p=0; p < rule->num_preds; ++p) {
            rule->preds[p]->base_pred = 1;
        }
    }
}

// *************************************************************************
void mark_all_as_derived(Cor_Collection *rules)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    int p;
    Cor_Clause *rule;
    int j, nrules;

    nrules = rules->count();

    for (j=0; j < nrules; j++) {
        rule = rules->get_ith(j);

        for (p=0; p < rule->num_preds; ++p) {
            rule->preds[p]->base_pred = 0;
        }
    }
}

// *************************************************************************
